{{ Old V2 program..
con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' 

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1     = 31
  TX1     = 30
  SDA     = 29
  SCL     = 28

  LED_MSB = 27
  LED_LSB = 20

  COL_3   = 16
  COL_0   = 19

con 

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control


obj

  term : "fullduplexserial"
  rc   : "RCTime3"                                                              ' get object

var

  long  wavcog
  long  stack[32]


pub main | t, idx, delay, rtime                                                 ' set method variable

  term.start(31, 30, %0000, 115200)
  pause(1)

  term.tx(CLS)
  term.str(string("By your command:", CR))

  rc.RCTIME_forever(4, 500, 1, @rtime)          ' start loading rtime with current RC value
  waitcnt(clkfreq / 1000 + cnt)                 ' allow a little time for rtime to get a value (may need to increase, or be able to decrease)
 
  term.str(string("rtime="))
  term.dec(rtime)
  term.str(string("     ",CR))
   
  wavcog := cognew(playsound(10, @Cylon, 0), @stack) + 1

  delay := clkfreq / 1500 * (rtime / 600)  ' file is 1.507 long ,, lower the 1000 for slower speed orig- 1000
  ' to speed up the rate change 400, up faster, down slower

  term.str(string("new rtime/400="))
  term.dec(rtime/600)
  term.str(string("     ",CR))
  t := cnt
  repeat

    repeat idx from 1 to 32        ' to
      out32(idx)
      waitcnt(t += delay)

    repeat idx from 32 to 1          ' fro
      out32(idx)
      waitcnt(t += delay)

 
pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)


pub out32(n)

'' Enables one of 32 LEDs in matrix
'' -- output is 0 (off), 1 to 32 (led on)

  outa[LED_MSB..LED_LSB]~                                       ' clear to start
  dira[LED_MSB..LED_LSB]~~

  outa[COL_3..COL_0]~
  dira[COL_3..COL_0]~~

  if (n => 1) and (n =< 32)                                     ' if valid
    --n
    outa[LED_MSB..LED_LSB] := 1 << (n & %111)
    outa[COL_3..COL_0]     := 1 << (n >> 3)

                                                                
pri playsound(pin, pntr, count) | rate, samples, addr, t        ' call with cognew

'' Plays 8-bit, mono audio file from DAT section
'' -- pin is pin for audio (uses CTRA)
'' -- pntr is start of audio
'' -- sampletm is sample timing in cnt ticks
'' -- count is number of plays before cog unloads itself

  if (count =< 0)                                               ' if 0, play "forever"
    count := posx

  rate    := clkfreq / long[pntr + 24]                          ' get rate from header
  samples := long[pntr + 40]                                    ' get samples from header

  frqa := $80 << 24                                             ' set to "0" 
  ctra := (%00110 << 26) + pin                                  ' duty cycle mode on pin
  dira[pin] := 1                                                ' make pin an output
  
  repeat count
    t := cnt
    addr := pntr + 44                                           ' skip over wav header
    repeat samples
      frqa := byte[addr++] << 24                                ' update dac
      waitcnt(t += rate)
      
  ctra := 0
  cogstop(cogid)


pri stopsound

  if wavcog
    cogstop(wavcog~ - 1)


dat

                byte                                            ' force byte alignment
                
Cylon           file    "eye_11.wav"  
CylonEOF        byte    0                                       ' end of file
}}


{{ new program starts here...
           
'' =================================================================================================
''
''   File....... V2 upgrade Cylon project.spin
''   Author..... Michael Yancy (stilgar.hammer@gmail.com)
''   Special thanks to Jon Williams, Brandon Nimon, Chip Gracey, Colin Fox, Duane Degn, Phil Pilgrim

'' =================================================================================================
 }}

con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' 

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1     = 31
  TX1     = 30
  SDA     = 29
  SCL     = 28

  LED_MSB = 27
  LED_LSB = 20

    COL_1   = 18
    COL_0   = 19
  

  
  ' rtime1 pin 4 
  ' rtime2 pin 5 
   'button pin 6
  ' sound pin 10


con 

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control
  
_numleds = 8
_firstled = 5
maxbright = 64


obj

  term    : "fullduplexserial"
  rc      : "RCTime3"                                                              ' get object
  led     : "led_pwm_1"

  
var

  long  wavcog
  long  stack[32]
  long  numleds_, firstled_, persistence_, leds[_numleds]    'these must appear in this order
  long  luminosity
  long  volume


PUB Scanner | x, t, idx, rtime1, rtime2, i

    
 
   term.start(31, 30, %0000, 115200)
  pause(1)

  term.tx(CLS)
  term.str(string("By your command:", CR))
  
  rc.RCTIME_forever(4, 500, 1, @rtime1)          ' start loading sweep speed rtime with current RC value
  waitcnt(clkfreq / 400 + cnt)                 ' allow a little time for rtime to get a value (may need to increase, or be able to decrease)

  rc.RCTIME_forever(5, 500, 1, @rtime2)          ' start loading persistence (trailing effect) rtime with current RC value
  waitcnt(clkfreq / 400 + cnt)                  ' allow a little time for rtime to get a value (may need to increase, or be able to decrease)
  


  term.str(string("Sweep speed = "))
  term.dec(rtime1/1200)
  term.str(string("     ",CR))

   term.str(string("Persistence trail = "))
  term.dec(rtime2/7000)
  term.str(string("     ",CR))
  t := cnt

 
  numleds_ := _numleds
  firstled_ := _firstled

  persistence_ := rtime2 / 7000         ' starting point 7000
  
  volume := 0                           'set volume  

  led.start(@numleds_)
  
  
  wavcog := cognew(playsound(10, @Cylon, 0), @stack) + 1      ' start sound player        

  repeat luminosity from 0 to maxbright
    'waitcnt(clkfreq / (rtime1 / 100)+ cnt)   
         volume := ++volume <# 32                        'ranp volume 0 - 255
                                                         ' center LED slowly go from 0 to maxbright = 64                                                      ' center led is P23
    repeat x from 7 to _numleds-9
      leds[x] := luminosity + 1 
    waitcnt(clkfreq / (rtime1 / 1000)+ cnt)              


  repeat (1)
    repeat x from 7 to _numleds-1
      leds[x] := maxbright
      waitcnt(clkfreq / (rtime1 / 1200)+ cnt)      ' maxbright remains 64 for this code and the rest of full programing
                                                   ' section to bring the sweep the leds to the end to start the full sweep sequence
    repeat x from _numleds-1 to 0
      leds[x] := maxbright
      waitcnt(clkfreq / (rtime1 / 1200)+ cnt)
 

  repeat
       
    repeat x from 0 to _numleds-1
      leds[x] := maxbright
      waitcnt(clkfreq / (rtime1 / 1200)+ cnt)                   ' The delay is after each are set, so they are individual
                                                                 ' full sweep sequence from edge to edge
    repeat x from _numleds-1 to 0                                ' leds P 27-P20,  P18-P19 matrix control
      leds[x] := maxbright
      waitcnt(clkfreq / (rtime1 / 1200)+ cnt)
 
  led.stop


pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)

    
pri playsound(pin, pntr, count) | rate, samples, addr, t        ' call with cognew

'' Plays 8-bit, mono audio file from DAT section
'' -- pin is pin for audio (uses CTRA)
'' -- pntr is start of audio
'' -- sampletm is sample timing in cnt ticks
'' -- count is number of plays before cog unloads itself

  if (count =< 0)                                               ' if 0, play "forever"
    count := posx

  rate    := clkfreq / long[pntr + 24]                          ' get rate from header
  samples := long[pntr + 40]                                    ' get samples from header

  frqa := $80 << 24                                             ' set to "0" 
  ctra := (%00110 << 26) + pin                                  ' duty cycle mode on pin
  dira[pin] := 1                                                ' make pin an output
  
  repeat count
    t := cnt
    addr := pntr + 44                                           ' skip over wav header
    repeat samples
      frqa := ((byte[addr++] - $80) * volume) << 16 + $8000_0000                                ' update dac, added volume control
      waitcnt(t += rate)
      
  ctra := 0
  cogstop(cogid)


pri stopsound

  if wavcog
    cogstop(wavcog~ - 1)


dat

                byte                                            ' force byte alignment
                
Cylon           file    "eye_11.wav"  
CylonEOF        byte    0                                       ' end of file

                      